CreateGraph
Creates a new Neptune Analytics graph.
Request Syntax
POST /graphs HTTP/1.1
Content-type: application/json
{
"deletionProtection": boolean,
"graphName": "string",
"kmsKeyIdentifier": "string",
"provisionedMemory": number,
"publicConnectivity": boolean,
"replicaCount": number,
"tags": {
"string" : "string"
},
"vectorSearchConfiguration": {
"dimension": number
}
}
URI Request Parameters
The request does not use any URI parameters.
Request Body
The request accepts the following data in JSON format.
- deletionProtection
-
Indicates whether or not to enable deletion protection on the graph. The graph can’t be deleted when deletion protection is enabled. (
trueorfalse).Type: Boolean
Required: No
- graphName
-
A name for the new Neptune Analytics graph to be created.
The name must contain from 1 to 63 letters, numbers, or hyphens, and its first character must be a letter. It cannot end with a hyphen or contain two consecutive hyphens. Only lowercase letters are allowed.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 63.
Pattern:
(?!g-)[a-z][a-z0-9]*(-[a-z0-9]+)*Required: Yes
- kmsKeyIdentifier
-
Specifies a KMS key to use to encrypt data in the new graph.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 1024.
Pattern:
arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}Required: No
- provisionedMemory
-
The provisioned memory-optimized Neptune Capacity Units (m-NCUs) to use for the graph. Min = 16
Type: Integer
Valid Range: Minimum value of 16. Maximum value of 24576.
Required: Yes
- publicConnectivity
-
Specifies whether or not the graph can be reachable over the internet. All access to graphs is IAM authenticated. (
trueto enable, orfalseto disable.Type: Boolean
Required: No
- replicaCount
-
The number of replicas in other AZs. Min =0, Max = 2, Default = 1.
ImportantAdditional charges equivalent to the m-NCUs selected for the graph apply for each replica.
Type: Integer
Valid Range: Minimum value of 0. Maximum value of 2.
Required: No
-
Adds metadata tags to the new graph. These tags can also be used with cost allocation reporting, or used in a Condition statement in an IAM policy.
Type: String to string map
Map Entries: Minimum number of 0 items. Maximum number of 50 items.
Key Length Constraints: Minimum length of 1. Maximum length of 128.
Key Pattern:
(?!aws:)[a-zA-Z+-=._:/]+Value Length Constraints: Minimum length of 0. Maximum length of 256.
Required: No
- vectorSearchConfiguration
-
Specifies the number of dimensions for vector embeddings that will be loaded into the graph. The value is specified as
dimension=value. Max = 65,535Type: VectorSearchConfiguration object
Required: No
Response Syntax
HTTP/1.1 201
Content-type: application/json
{
"arn": "string",
"buildNumber": "string",
"createTime": number,
"deletionProtection": boolean,
"endpoint": "string",
"id": "string",
"kmsKeyIdentifier": "string",
"name": "string",
"provisionedMemory": number,
"publicConnectivity": boolean,
"replicaCount": number,
"sourceSnapshotId": "string",
"status": "string",
"statusReason": "string",
"vectorSearchConfiguration": {
"dimension": number
}
}
Response Elements
If the action is successful, the service sends back an HTTP 201 response.
The following data is returned in JSON format by the service.
- arn
-
The ARN of the graph.
Type: String
- buildNumber
-
The build number of the graph software.
Type: String
- createTime
-
The time when the graph was created.
Type: Timestamp
- deletionProtection
-
A value that indicates whether the graph has deletion protection enabled. The graph can't be deleted when deletion protection is enabled.
Type: Boolean
- endpoint
-
The graph endpoint.
Type: String
- id
-
The ID of the graph.
Type: String
Pattern:
g-[a-z0-9]{10} - kmsKeyIdentifier
-
Specifies the KMS key used to encrypt data in the new graph.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 1024.
Pattern:
arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36} - name
-
The graph name. For example:
my-graph-1.The name must contain from 1 to 63 letters, numbers, or hyphens, and its first character must be a letter. It cannot end with a hyphen or contain two consecutive hyphens. Only lowercase letters are allowed.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 63.
Pattern:
(?!g-)[a-z][a-z0-9]*(-[a-z0-9]+)* - provisionedMemory
-
The provisioned memory-optimized Neptune Capacity Units (m-NCUs) to use for the graph.
Min = 16
Type: Integer
Valid Range: Minimum value of 16. Maximum value of 24576.
- publicConnectivity
-
Specifies whether or not the graph can be reachable over the internet. All access to graphs is IAM authenticated.
NoteIf enabling public connectivity for the first time, there will be a delay while it is enabled.
Type: Boolean
- replicaCount
-
The number of replicas in other AZs.
Default: If not specified, the default value is 1.
Type: Integer
Valid Range: Minimum value of 0. Maximum value of 2.
- sourceSnapshotId
-
The ID of the source graph.
Type: String
Pattern:
gs-[a-z0-9]{10} - status
-
The current status of the graph.
Type: String
Valid Values:
CREATING | AVAILABLE | DELETING | RESETTING | UPDATING | SNAPSHOTTING | FAILED | IMPORTING | STARTING | STOPPING | STOPPED - statusReason
-
The reason the status was given.
Type: String
- vectorSearchConfiguration
-
The vector-search configuration for the graph, which specifies the vector dimension to use in the vector index, if any.
Type: VectorSearchConfiguration object
Errors
For information about the errors that are common to all actions, see Common Error Types.
- ConflictException
-
Raised when a conflict is encountered.
- message
-
A message describing the problem.
- reason
-
The reason for the conflict exception.
HTTP Status Code: 409
- InternalServerException
-
A failure occurred on the server.
- message
-
A message describing the problem.
HTTP Status Code: 500
- ServiceQuotaExceededException
-
A service quota was exceeded.
- quotaCode
-
Service quota code of the resource for which quota was exceeded.
- resourceId
-
The identifier of the resource that exceeded quota.
- resourceType
-
The type of the resource that exceeded quota. Ex: Graph, Snapshot
- serviceCode
-
The service code that exceeded quota.
HTTP Status Code: 402
- ThrottlingException
-
The exception was interrupted by throttling.
- message
-
A message describing the problem.
HTTP Status Code: 429
- ValidationException
-
A resource could not be validated.
- message
-
A message describing the problem.
- reason
-
The reason that the resource could not be validated.
HTTP Status Code: 400
See Also
For more information about using this API in one of the language-specific AWS SDKs, see the following: